#include <string>
#include <string.h>
#include <stdio.h>
#include <fcntl.h>
#include <unistd.h>
#include <linux/joystick.h>
#include "listener.h"
#include <vector>

#ifndef JOYSTICK_H

#define EVER (;;)
using namespace std;
class joystick
{
  public:
    joystick(const std::string &dev,int flags = O_RDONLY);
    ~joystick();
    std::vector<int> getAxis();
    std::vector<int> getButtons();
    int getAxis(const int& a);
    int getButton(const int& b);
    void setAxis(const int& a,const int& val);
    void setButton(const int& b,const int& val);
    int run();
    void addListener(listener* l);
  protected:
    int fd;
    std::string joystick_name;
    std::vector<int> axis;
    std::vector<int> buttons;
    std::vector<listener*> jsl;
  private:
    joystick(){}
};

#endif
